package atenarium.utils.report;

import java.util.LinkedList;
import java.util.List;

public class DepartmentReportDetails {

	private static final long serialVersionUID = 1L;
	
	private ReportDetails myReportDetails;
	private String myDepartment;
	private String myDownloadLink;
	
	public DepartmentReportDetails(ReportDetails aReportDetails, String aDepartment, String aDownloadLink) {
		myReportDetails = aReportDetails;
		myDepartment = aDepartment;
		myDownloadLink = aDownloadLink;
	}
	
	
	public String getDownloadLink() { return myDownloadLink; }
	public String getDepartment() { return myDepartment; }
	public String getTitle() { return myReportDetails.getTitle(); }
	public String getId() { return myReportDetails.getId(); }
	public String getDate() { return myReportDetails.getDate(); }
	public String getAuthor() { return myReportDetails.getAuthor(); }
	public String getKeywords() { return myReportDetails.getKeywords(); }
	public boolean isCollection() { return myReportDetails.isACollection(); }
	
	public static List<String> getAuthors(DepartmentReportDetails[] aDepartmentReportDetailsList) {
		List<String> methodAuthorsList = new LinkedList<String>();
		for(DepartmentReportDetails eachDepartmentReportDetails : aDepartmentReportDetailsList)
			methodAuthorsList.add(eachDepartmentReportDetails.getAuthor());
		return methodAuthorsList;
	}
	
	public static List<String> getAuthors(List<DepartmentReportDetails> aDepartmentReportDetailsList) {
		List<String> methodAuthorsList = new LinkedList<String>();
		for(DepartmentReportDetails eachDepartmentReportDetails : aDepartmentReportDetailsList)
			methodAuthorsList.add(eachDepartmentReportDetails.getAuthor());
		return methodAuthorsList;
	}
	
	public static List<String> getTitles(DepartmentReportDetails[] aDepartmentReportDetailsList) {
		List<String> methodTitlesList = new LinkedList<String>();
		for(DepartmentReportDetails eachDepartmentReportDetails : aDepartmentReportDetailsList)
			methodTitlesList.add(eachDepartmentReportDetails.getTitle());
		return methodTitlesList;
	}
	
	public static List<String> getTitles(List<DepartmentReportDetails> aDepartmentReportDetailsList) {
		List<String> methodTitlesList = new LinkedList<String>();
		for(DepartmentReportDetails eachDepartmentReportDetails : aDepartmentReportDetailsList)
			methodTitlesList.add(eachDepartmentReportDetails.getTitle());
		return methodTitlesList;
	}
	
	public static List<String> getKeywords(DepartmentReportDetails[] aDepartmentReportDetailsList) {
		List<String> methodKeywordsList = new LinkedList<String>();
		for(DepartmentReportDetails eachDepartmentReportDetails : aDepartmentReportDetailsList)
			methodKeywordsList.add(eachDepartmentReportDetails.getKeywords());
		return methodKeywordsList;
	}
	
	public static List<String> getKeywords(List<DepartmentReportDetails> aDepartmentReportDetailsList) {
		List<String> methodKeywordsList = new LinkedList<String>();
		for(DepartmentReportDetails eachDepartmentReportDetails : aDepartmentReportDetailsList)
			methodKeywordsList.add(eachDepartmentReportDetails.getKeywords());
		return methodKeywordsList;
	}

}
