package atenarium.web.beans.filters;

import java.util.LinkedList;
import java.util.List;
import java.util.StringTokenizer;

import atenarium.utils.Constants;
import atenarium.utils.report.DepartmentReportDetails;

public class KeywordsFilterBean extends FilterBean {
	
	private String myName = Constants.FILTER_BEAN_NAME_KEYWORDS;
	private List<String> myKeywordsList;
	private String myProperty;
	
	public KeywordsFilterBean(List<String> aKeywordsList) {
		setupKeywordsList(aKeywordsList);
	}
	
	private void setupKeywordsList(List<String> aKeywordsList) {
		myKeywordsList = new LinkedList<String>();
		for(String eachKeywordsString : aKeywordsList)
			addTokens(myKeywordsList,eachKeywordsString);
	}
	
	private void addTokens(List<String> aListToAppendTo, String aKeywordsString) {
		StringTokenizer methodStringTokenizer = new StringTokenizer(aKeywordsString,Constants.KEYWORDS_DELIMITER);
		while(methodStringTokenizer.hasMoreTokens())
			aListToAppendTo.add(methodStringTokenizer.nextToken());
	}

	public String getName() { return myName; }
	public void setProperty(String aProperty) { myProperty = aProperty; }
	public String getProperty() { return myProperty; }
	protected List<String> getObjectList() { return myKeywordsList; }

	public String getFilteredField(DepartmentReportDetails aDepartmentReportDetails) {
		return aDepartmentReportDetails.getKeywords();
	}
	
	public DepartmentReportDetails[] doFiltering(DepartmentReportDetails[] aDepartmentReportDetailsArray) {
		String methodProperty = getProperty();
		if (methodProperty==null || methodProperty.compareTo("")==0)
			return aDepartmentReportDetailsArray;
		else {
			List<DepartmentReportDetails> methodDepRepDetailsList = new LinkedList<DepartmentReportDetails>();
			for(DepartmentReportDetails eachRepDepDetails : aDepartmentReportDetailsArray) {
				String eachKeywordsString = getFilteredField(eachRepDepDetails).toLowerCase();
				String singleKeywordPrefix = methodProperty.toLowerCase();
				if (eachKeywordsString.startsWith(singleKeywordPrefix) || 
						eachKeywordsString.contains(Constants.KEYWORDS_DELIMITER + singleKeywordPrefix))
					methodDepRepDetailsList.add(eachRepDepDetails); 
			}
			return methodDepRepDetailsList.toArray(new DepartmentReportDetails[methodDepRepDetailsList.size()]);
		}
	}

	protected void setObjectList(List<DepartmentReportDetails> aDepartmentReportDetailsList) {
		setupKeywordsList(DepartmentReportDetails.getTitles(aDepartmentReportDetailsList));
	}

}
