package departmentarium.utils;

public final class Constants {

	public static final boolean VERBOSE = true;
	
	public static final int STARTING_ID = 1000;
	public static final String CONFIGURATION_PRIMARY_KEY = "Configuration Primary Key";
	public static final String CALENDAR_SEPARATOR = "/";
	
	//Exception messages
	public static final String CANNOT_CREATE_ADMIN = "Cannot create more than one admin";
	public static final String CANNOT_CREATE_LOGIN = "Cannot create a user with the same login";
	public static final String WRONG_PASSWORD = "Wrong user or password";
	public static final String DUPLICATE_REPORT = "Duplicated report, please use update() if you need to update it";
	public static final String WRONG_REPORT = "Cannot update a report with a different Id or Author";
	public static final String USER_NOT_DEFINED = "No user defined";
	public static final String REPORT_ID_WRONG_STRING = "Cannot create a correct ReportId from the provided string";
	public static final String NOT_SAME_AUTHOR = "The author is not the user putting the report in";
	public static final String CANNOT_CREATE_USER = "Only admin can create a new user";
	public static final String CANNOT_REMOVE_USER = "Only admin can delete a user";
	public static final String CANNOT_GET_USERS = "Only admin can get users list";
	public static final String CANNOT_CREATE_CONFIGURATION = "Only Admin could change the configuration";
	public static final String ID_MORE_THAN_ONE = "Cannot have more than one last id";
	public static final String CONFIGURATION_NOT_PRESENT = "Configuration not present";
	public static final String CONFIGURATION_PREFIX_ERROR = "Cannot get prefix correctly from Configuration";
	public static final String REPORT_ID_NOT_AVAILABLE = "The specified ReportId is not available";
	public static final String BAD_DEP_CONFIGURATION_ARGUMENTS = "One or more arguments in departmentarium configuration are wrong";
	
	//metadata strings
	public static final String ID = "Id";
	public static final String AUTHOR = "Author";
	public static final String KEYWORDS = "Keywords";
	public static final String ISCOLLECTION = "IsCollection";
	public static final String DATE = "Creation Date";
	public static final String TITLE = "Title";
	
	//pdf departmentarium specific metadata -not mandatory
	public static final String CREATOR_KEY = "Creator";
	public static final String CREATOR_VALUE = "Departmentarium PDF Manager";
	public static final String METADATA_MISSING_FIELD = "Metadata is missing one or more mandatory fields";
	public static final String REPORT_ID_PREFIX_NUMBER_SEPARATOR = "-";
	
	//coded names
	public static final String REPORT_LOCAL_EJB_HOME = "ejb/Report";
	public static final String USER_LOCAL_EJB_HOME = "ejb/User";
	public static final String CONFIGURATION_LOCAL_EJB_HOME = "ejb/Configuration";
	public static final String DEPARTMENTARIUMWS_EJB_HOME = "ejb/Departmentarium";
	public static final String ID_LOCAL_EJB_HOME = "ejb/Id";
	public static final String DEPARTMENTARIUM_EJB_HOME = "java:comp/env/ejb/Departmentarium";
	
	// RPC
	public static final String RMI_PREFIX = "/axis/services/";
	public static final String DEPARTMENTARIUM_WS = "DepartmentariumWS";
	public static final String ATENARIUM_REGISTRATION = "registerDepartment";
	public static final String ATENARIUM_UNREGISTRATION = "unregisterDepartment";
	public static final String ATENARIUM_WS = "AtenariumWS";
	
	//actions
	public static final String ACTION_ADD_USER = "Add New User";
	public static final String ID_ACTION_ADD_USER = "Add_New_User";
	public static final String ACTION_ADD_USER_DONE = "done";

	public static final String ACTION_VIEW_USERS = "View Departmentarium Users";
	public static final String ID_ACTION_VIEW_USERS = "View_Users";
	
	public static final String ACTION_SETUP_DEPARTMENTARIUM = "Setup Departmentarium";
	public static final String ID_ACTION_SETUP_DEPARTMENTARIUM = "Setup_Departmentarium";
	public static final String ACTION_SETUP_DEPARTMENTARIUM_DONE = "done";
	
	
	public static final String ACTION_REPORT_WIZARD = "Add New Report - Wizard";
	public static final String ID_ACTION_REPORT_WIZARD = "Add_Report_Wizard";
	public static final String ACTION_REPORT_WIZARD_DONE = "done";
	
	public static final String ACTION_VIEW_REPORTS_DETAILS = "View Published Reports";
	public static final String ID_ACTION_VIEW_REPORTS_DETAILS = "View_Reports_Details";
	
	public static final String ACTION_ADD_REPORT = "Add New Report";
	public static final String ID_ACTION_ADD_REPORT = "Add_Report";

	public static final String ACTION_DONE = "done";
	public static final String ACTION_NOT_DONE = "error";
	
	public static final String NOT_VALID_USER = "";
	public static final String ADMIN = "admin";
	public static final String USER = "user";
	
}
