package departmentarium.utils;

import javax.naming.InitialContext;
import javax.naming.NamingException;
import javax.rmi.PortableRemoteObject;

import departmentarium.interfaces.ConfigurationLocalHome;
import departmentarium.interfaces.DepartmentariumHome;
import departmentarium.interfaces.ReportLocalHome;
import departmentarium.interfaces.UserLocalHome;

public final class EJBGetter {
	
	public static ReportLocalHome getReportLocalHome() throws NamingException {
		InitialContext initialContext = new InitialContext();
        Object objref = initialContext.lookup(Constants.REPORT_LOCAL_EJB_HOME);

        return (ReportLocalHome)PortableRemoteObject.narrow(objref,
        		ReportLocalHome.class);
	}
	
    public static UserLocalHome getUserLocalHome() throws NamingException {
        InitialContext initial = new InitialContext();
        Object objref = initial.lookup(Constants.USER_LOCAL_EJB_HOME);

        return (UserLocalHome) PortableRemoteObject.narrow(objref,
        		UserLocalHome.class);
    }
    
    public static DepartmentariumHome getDepartmentariumHome() throws NamingException {
    	InitialContext initial = new InitialContext();
        Object objref = initial.lookup(Constants.DEPARTMENTARIUM_EJB_HOME);

        return (DepartmentariumHome) PortableRemoteObject.narrow(objref,
        		DepartmentariumHome.class);
    }
    
    public static DepartmentariumHome getDepartmentariumWSHome() throws NamingException {
    	InitialContext initial = new InitialContext();
        Object objref = initial.lookup(Constants.DEPARTMENTARIUMWS_EJB_HOME);

        return (DepartmentariumHome) PortableRemoteObject.narrow(objref,
        		DepartmentariumHome.class);
    }
    
    public static ConfigurationLocalHome getConfigurationLocalHome() throws NamingException {
    	InitialContext initial = new InitialContext();
        Object objref = initial.lookup(Constants.CONFIGURATION_LOCAL_EJB_HOME);

        return (ConfigurationLocalHome) PortableRemoteObject.narrow(objref,
        		ConfigurationLocalHome.class);
    }
    
}
