package departmentarium.utils.pdf;

import java.io.ByteArrayOutputStream;
import java.io.IOException;
import java.util.HashMap;
import java.util.Map;


import com.lowagie.text.DocumentException;
import com.lowagie.text.pdf.PdfReader;
import com.lowagie.text.pdf.PdfStamper;
import com.lowagie.text.xml.xmp.XmpWriter;

import departmentarium.utils.Constants;


public class PDFManager {
	
	public static MetadataDetails getMetadata(byte[] aPdfIn) throws IOException, MetadataException {
		PdfReader reader = new PdfReader(aPdfIn);
		Map info = reader.getInfo();
		MetadataDetails methodMetadataDetails = new MetadataDetails(info);
		return methodMetadataDetails;
	}
	
	public static byte[] createFromMetadataAndDoc(MetadataDetails aMetadataDetails, byte[] aPdfIn) 
		throws IOException, DocumentException {
		ByteArrayOutputStream returnOutput = new ByteArrayOutputStream();
		PdfReader reader = new PdfReader(aPdfIn);
		PdfStamper stamper = new PdfStamper(reader, returnOutput);		
		HashMap info = aMetadataDetails.getDetailsMap();
		addMyMeta(info);
		stamper.setMoreInfo(info);
		ByteArrayOutputStream baos = new ByteArrayOutputStream();
		XmpWriter xmp = new XmpWriter(baos, info);
		xmp.close();
		stamper.setXmpMetadata(baos.toByteArray());
		stamper.close();
		return returnOutput.toByteArray();
	}
	
	private static void addMyMeta(HashMap aHashMap) {
		aHashMap.put(Constants.CREATOR_KEY,Constants.CREATOR_VALUE);
	}

}
