package departmentarium.web;

import javax.ejb.FinderException;
import javax.naming.NamingException;
import javax.servlet.ServletContextEvent;
import javax.servlet.ServletContextListener;

import departmentarium.interfaces.ConfigurationLocal;
import departmentarium.interfaces.ConfigurationLocalHome;
import departmentarium.utils.*;
import departmentarium.utils.wrappers.ConfigurationPojo;

public final class RegistrationServlet implements ServletContextListener {
	
	private ConfigurationLocal myConfigurationLocal;
	
	private boolean isDepartmentariumConfigured() {
			ConfigurationLocalHome home;
			try {
				home = EJBGetter.getConfigurationLocalHome();
			} catch (NamingException e1) { return false; }
			try {
				home.findByPrimaryKey(Constants.CONFIGURATION_PRIMARY_KEY);
			} catch (FinderException e) { return false; }
			return true;
	}
	
	private void doCall(String aMethodToExecute) {
		WebServiceManager.contactAtenarium(aMethodToExecute,new ConfigurationPojo(myConfigurationLocal));
	}
	
	public void contextInitialized(ServletContextEvent sce) {
		if (isDepartmentariumConfigured())
			doCall(Constants.ATENARIUM_REGISTRATION);
	}

	public void contextDestroyed(ServletContextEvent sce) {
		if (isDepartmentariumConfigured())
			doCall(Constants.ATENARIUM_UNREGISTRATION);
	}

}
