package departmentarium.web.beans.actions;

import departmentarium.utils.Constants;
import departmentarium.web.beans.UserJavaBean;

public class AddUserActionBean implements ActionBean {

	private UserJavaBean myUserJavaBean;
	
	private String newUsername;
	private String newPassword;
	
	private boolean isSelected = false;

	private String myError;
	
	public AddUserActionBean(UserJavaBean aUserJavaBean) {
		myUserJavaBean = aUserJavaBean;
	}
	
	public String getName() { return Constants.ACTION_ADD_USER; }
	public String getId() { return Constants.ID_ACTION_ADD_USER; }
	
	public String getError() { return myError; }
	public void setError(Exception anException) { myError = anException.getMessage(); }
	
	public String doSelection() { 
		isSelected = true;
		myUserJavaBean.setSelectedAction(this);
		return getId(); 
	}

	public boolean isSelected() {
		return isSelected;
	}
	
	private void reset() {
		isSelected = false;
		setUsername("");
		setPassword("");
	}

	public String doUnselection() {
		reset();
		return getId();
	}
	
	public void setUsername(String aUsername) {
		newUsername = aUsername;
	}
	
	public String getUsername() { return newUsername; }
	
	public void setPassword(String aPassword) {
		newPassword = aPassword;
	}
	
	public String getPassword() { return newPassword; }
	
	public String doAction() {
		String currentUsername = myUserJavaBean.getUsername();
		String currentPassword = myUserJavaBean.getPassword();
		try {
			myUserJavaBean.getDepartmentarium().createUser(currentUsername,currentPassword,newUsername,newPassword);
		} catch (Exception e) {
			setError(e);
			return Constants.ACTION_NOT_DONE;
		}
		return Constants.ACTION_DONE;
	}

}
