package departmentarium.web.beans.actions;

import org.apache.myfaces.custom.fileupload.UploadedFile;

import departmentarium.utils.Constants;
import departmentarium.utils.wrappers.ReportDetails;
import departmentarium.web.beans.UserJavaBean;

public class ViewReportActionBean implements ActionBean {
	
	private UserJavaBean myUserJavaBean;
	private ReportDetailsAction[] myReportsDetailsActions;
	private boolean isSelected = false;
	private UploadedFile myFile;
	private String myError;
	
	public ViewReportActionBean(UserJavaBean aUserJavaBean) {
		myUserJavaBean = aUserJavaBean;
		myReportsDetailsActions = updateReportsDetailsActions();
	}
	
	public String getName() { return Constants.ACTION_VIEW_REPORTS_DETAILS; }
	public String getId() { return Constants.ID_ACTION_VIEW_REPORTS_DETAILS; }
	
    public UploadedFile getMyFile() { return myFile; }
    public void setMyFile(UploadedFile aFile) { myFile = aFile; }
    
	public String getError() { return myError; }
	public void setError(Exception anException) { myError = anException.getMessage(); }
	
	public String doSelection() { 
		isSelected = true;
		myReportsDetailsActions = updateReportsDetailsActions();
		myUserJavaBean.setSelectedAction(this);
		return getId(); 
	}

	public boolean isSelected() { return isSelected; }
	
	private void reset() { isSelected = false; }

	public String doUnselection() {
		reset();
		return getId();
	}
	
	public ReportDetailsAction[] getReportsDetailsActions() { return myReportsDetailsActions; }
	
	private ReportDetailsAction[] wrapReportDetailsArray(ReportDetails[] aReportDetailsArray) {
		int length = aReportDetailsArray.length;
		ReportDetailsAction[] methodReportDetailsAction = new ReportDetailsAction[length];
		for(int i=0;i<length;i++)
			methodReportDetailsAction[i] = new ReportDetailsAction(aReportDetailsArray[i],myUserJavaBean);
		return methodReportDetailsAction;
	}
	
	private ReportDetailsAction[] updateReportsDetailsActions() {
		String currentUsername = myUserJavaBean.getUsername();
		String currentPassword = myUserJavaBean.getPassword();
		try {
			ReportDetails[] methodReportDetailsArray = myUserJavaBean.getDepartmentarium().getUserReportsDetails(currentUsername,currentPassword);
			return wrapReportDetailsArray(methodReportDetailsArray);
		} catch (Exception e) {
			e.printStackTrace();
			return null;
		}
	}	
	
	public String doAction() { return null; }

}
