package departmentarium.web.beans.actions;

import departmentarium.utils.Constants;
import departmentarium.utils.wrappers.UserPojo;
import departmentarium.web.beans.UserJavaBean;

public class ViewUsersActionBean implements ActionBean {
	
	private UserJavaBean myUserJavaBean;
	private UserPojo[] myUsers;
	
	private boolean isSelected = false;
	private String myError;
	
	public ViewUsersActionBean(UserJavaBean aUserJavaBean) {
		myUserJavaBean = aUserJavaBean;
		myUsers = updateUsers();
	}
	
	public String getName() { return Constants.ACTION_VIEW_USERS; }
	public String getId() { return Constants.ID_ACTION_VIEW_USERS; }
	
	public String getError() { return myError; }
	public void setError(Exception anException) { myError = anException.getMessage(); }
	
	public String doSelection() { 
		isSelected = true;
		myUsers = updateUsers();
		myUserJavaBean.setSelectedAction(this);
		return getId(); 
	}

	public boolean isSelected() { return isSelected; }
	
	private void reset() { isSelected = false; }

	public String doUnselection() {
		reset();
		return getId();
	}
	
	public UserPojo[] getUsers() {
		return myUsers;
	}
	
	private UserPojo[] updateUsers() {
		String currentUsername = myUserJavaBean.getUsername();
		String currentPassword = myUserJavaBean.getPassword();
		try {
			return myUserJavaBean.getDepartmentarium().getUsers(currentUsername,currentPassword);
		} catch (Exception e) {
			e.printStackTrace();
			return null;
		}

	}	
	
	public String doAction() {
		String currentUsername = myUserJavaBean.getUsername();
		String currentPassword = myUserJavaBean.getPassword();
		for(int i=0; i<myUsers.length; i++) {
			if (myUsers[i].isToDelete()) {
				try {
					myUserJavaBean.getDepartmentarium().removeUser(currentUsername,currentPassword,myUsers[i].getUsername());
				} catch (Exception e) {
					setError(e);
					return Constants.ACTION_NOT_DONE;
				} 
			}
		}
		myUsers = updateUsers();
		return Constants.ACTION_DONE;
	}

}
